import { NgModule, ModuleWithProviders } from '@angular/core';

import { ModuleConfig } from '@ucap/api-common';

import { _MODULE_CONFIG } from './config/token';

import { CommonApiService } from './services/common-api.service';

const SERVICES = [CommonApiService];

@NgModule({})
export class CommonApiRootModule {}

@NgModule({})
export class CommonApiModule {
  public static forRoot(
    config: ModuleConfig
  ): ModuleWithProviders<CommonApiRootModule> {
    return {
      ngModule: CommonApiRootModule,
      providers: [{ provide: _MODULE_CONFIG, useValue: config }, ...SERVICES]
    };
  }
}
