import { ValidatorFn, AbstractControl } from '@angular/forms';

import { StringUtil as UcapStringUtil } from '@ucap/core';

export class StringUtil extends UcapStringUtil {
  public static checkSpecialCharacter(): ValidatorFn {
    const fn = (control: AbstractControl): { [key: string]: any } | null => {
      const forbidden = /[\{\}\[\]\/?.;:|\)*~`!^+<>@\#$%&\\\=\(\'\"]/g.test(
        control.value
      );
      return forbidden ? { groupName: { value: control.value } } : null;
    };

    return fn;
  }
}
