import { NgModule, ModuleWithProviders } from '@angular/core';
import { CommonModule } from '@angular/common';

import { ModuleConfig } from './config/module-config';
import { _MODULE_CONFIG } from './config/token';

import { LogService } from './services/log.service';

const SERVICES = [LogService];

@NgModule({
  declarations: [],
  imports: [],
  exports: []
})
export class LoggerRootModule {}

@NgModule({
  imports: [CommonModule]
})
export class LoggerModule {
  public static forRoot(
    config: ModuleConfig
  ): ModuleWithProviders<LoggerRootModule> {
    return {
      ngModule: LoggerRootModule,
      providers: [{ provide: _MODULE_CONFIG, useValue: config }, ...SERVICES]
    };
  }
}
