import { NgModule, ModuleWithProviders } from '@angular/core';

import { ModuleConfig } from '@ucap/protocol-event';

import { _MODULE_CONFIG } from './config/token';

import { EventProtocolService } from './services/event-protocol.service';

const SERVICES = [EventProtocolService];

@NgModule({})
export class EventProtocolRootModule {}

@NgModule({})
export class EventProtocolModule {
  public static forRoot(
    config: ModuleConfig
  ): ModuleWithProviders<EventProtocolRootModule> {
    return {
      ngModule: EventProtocolRootModule,
      providers: [{ provide: _MODULE_CONFIG, useValue: config }, ...SERVICES]
    };
  }
}
