import { NgModule, ModuleWithProviders } from '@angular/core';

import { ModuleConfig } from '@ucap/protocol-file';

import { _MODULE_CONFIG } from './config/token';

import { FileProtocolService } from './services/file-protocol.service';

const SERVICES = [FileProtocolService];

@NgModule({})
export class FileProtocolRootModule {}

@NgModule({})
export class FileProtocolModule {
  public static forRoot(
    config: ModuleConfig
  ): ModuleWithProviders<FileProtocolRootModule> {
    return {
      ngModule: FileProtocolRootModule,
      providers: [{ provide: _MODULE_CONFIG, useValue: config }, ...SERVICES]
    };
  }
}
