import { createAction, props } from '@ngrx/store';

import { AuthRequest, AuthResponse } from '@ucap/protocol-query';

/**
 * retrieve authorization information
 */
export const auth = createAction(
  '[ucap::authentication::authorization] auth',
  props<{ req: AuthRequest }>()
);
/**
 * Success of auth request
 */
export const authSuccess = createAction(
  '[ucap::authentication::authorization] auth Success',
  props<{ res: AuthResponse }>()
);
/**
 * Failure of auth request
 */
export const authFailure = createAction(
  '[ucap::authentication::authorization] auth Failure',
  props<{ error: any }>()
);
