import { createFeatureSelector, createSelector } from '@ngrx/store';

import * as CommonState from './common/state';
import * as RoomState from './room/state';
import * as ChattingState from './chatting/state';

export const KEY_FEATURE = 'chat';

export interface State {
  common: CommonState.State;
  room: RoomState.State;
  chatting: ChattingState.State;
}

export const Selector = createFeatureSelector<State>(KEY_FEATURE);

export const CommonSelector = CommonState.selectors(
  createSelector(Selector, (state: State) => state.common)
);

export const RoomSelector = RoomState.selectors(
  createSelector(Selector, (state: State) => state.room)
);

export const ChattingSelector = ChattingState.selectors(
  createSelector(Selector, (state: State) => state.chatting)
);
