import { createAction, props } from '@ngrx/store';

import {
  DeptRequest,
  DeptInfo,
  DeptUserRequest,
  UserInfoSS
} from '@ucap/protocol-query';

/**
 * retrieve department information list
 */
export const dept = createAction(
  '[ucap::organization::department] dept',
  props<{ req: DeptRequest }>()
);
/**
 * Success of dept request
 */
export const deptSuccess = createAction(
  '[ucap::organization::department] dept Success',
  props<{ departmentInfoList: DeptInfo[] }>()
);
/**
 * Failure of dept request
 */
export const deptFailure = createAction(
  '[ucap::organization::department] dept Failure',
  props<{ error: any }>()
);

/**
 * retrieve my department information list
 */
export const myDeptUser = createAction(
  '[ucap::organization::department] myDeptUser',
  props<{ req: DeptUserRequest }>()
);
/**
 * Success of dept request
 */
export const myDeptUserSuccess = createAction(
  '[ucap::organization::department] myDeptUser Success',
  props<{ userInfos: UserInfoSS[] }>()
);
/**
 * Failure of dept request
 */
export const myDeptUserFailure = createAction(
  '[ucap::organization::department] myDeptUser Failure',
  props<{ error: any }>()
);
